package com.fractalite.hermes.teldar.parsers;


import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Currency;
import java.util.Date;
import java.util.GregorianCalendar;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPathExpressionException;

import org.apache.camel.Exchange;
import org.apache.camel.InvalidPayloadException;
import org.apache.camel.Processor;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;
import org.xml.sax.SAXException;

import com.fractalite.models.travel.PaxType;
import com.fractalite.models.travel.Traveller;
import com.fractalite.models.travel.stay.Room;


public abstract  class TeldarParsers  implements Processor {
	
	final Currency outputCurrency=Currency.getInstance("MAD");
	final String language="FRA";
	final DateTimeFormatter dateParser = DateTimeFormat.forPattern("yyyy/MM/dd");//"MM/dd/yyyy"
	final SimpleDateFormat formatDateJour = new SimpleDateFormat("yyyyMMdd");
	final SimpleDateFormat formatter = new SimpleDateFormat("yyyy/MM/dd");

	@Override
	public abstract void process(Exchange exchange) throws InvalidPayloadException, ParserConfigurationException, SAXException, IOException, XPathExpressionException, ParseException ;

	//public double tauxChange=11.55;
	public static int getAdultCount(String code) {
		
		int AdultCount=1;
		if(code.equals("SB"))
			AdultCount=1;
		else if(code.equals("DB"))
			AdultCount=2;
			else if(code.equals("TR"))
				AdultCount=3;
				else if(code.equals("Q"))
					AdultCount=4;
		
		return AdultCount;
	}
	
	

	public static int countDaysBetween(Date start, Date end) {
	
		final int MILLISECONDS_IN_DAY = 1000 * 60 * 60 * 24;
		if (end.before(start)) {
			//throw new IllegalArgumentException("The end date must be later than the start date");
			return 0;
		}

		//accor all hours mins and secs to zero on start date
		Calendar startCal = GregorianCalendar.getInstance();
		startCal.setTime(start);
		startCal.set(Calendar.HOUR_OF_DAY, 0);
		startCal.set(Calendar.MINUTE, 0);
		startCal.set(Calendar.SECOND, 0);
		long startTime = startCal.getTimeInMillis();

		//accor all hours mins and secs to zero on end date
		Calendar endCal = GregorianCalendar.getInstance();
		endCal.setTime(end);
		endCal.set(Calendar.HOUR_OF_DAY, 0);
		endCal.set(Calendar.MINUTE, 0);
		endCal.set(Calendar.SECOND, 0);
		long endTime = endCal.getTimeInMillis();

		return (int) ((endTime - startTime) / MILLISECONDS_IN_DAY);
	}
	
	public static int childCount(Room room) {
		
		int childNbre=0;
		for(Traveller traveller : room.getGuests())
			if(traveller.getClassification().equals(PaxType.CHILD))
				childNbre++;
				
		return childNbre;
	}
	
}
