package com.fractalite.hermes.teldar.services;

import javax.xml.datatype.DatatypeConfigurationException;
import org.apache.camel.Exchange;
import org.apache.camel.InvalidPayloadException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.fractalite.hermes.teldar.cfg.TeldarRouteBuilder;
import com.fractalite.models.commerce.Order;
import com.fractalite.models.travel.stay.StayItem2;
import com.gekko_holding.webservice.v2_4.CancelBookingSegment;
import com.gekko_holding.webservice.v2_4.CustomerIdentification;


public class CancelBookingsegmentTeldRequest extends TeldarServices {

	protected static Logger logger = LoggerFactory.getLogger(CancelBookingsegmentTeldRequest.class);

	@Override
	public void process(Exchange exchange) throws InvalidPayloadException, DatatypeConfigurationException {

		logger.info("Invoking Teldar CancelBookingsegmentRequest Processor.......");
		Order order = exchange.getIn().getMandatoryBody(Order.class);
		exchange.setProperty("TeldarOrder", order);
		CancelBookingSegment cancel = addBooking(order);
		logger.info("End Teldar CancelBookingsegmentRequest Processor.......");
		exchange.getIn().setBody(cancel, CancelBookingSegment.class);

	}

	private CancelBookingSegment addBooking(Order order) {

		CancelBookingSegment cancel = new CancelBookingSegment();
		
		CustomerIdentification customeridentification =new CustomerIdentification();
		customeridentification.setClientId(TeldarRouteBuilder.clientId);
		customeridentification.setPassword(TeldarRouteBuilder.password);
		customeridentification.setCustomerKey(TeldarRouteBuilder.customerKey);
		
		cancel.setIdentification(customeridentification);
		cancel.setLanguage("EN");
		cancel.setSegmentId("EXTERNAL:"+order.getMetaFirst("ExternalRef").split("_")[2]);
		
		
		//RM_EXTERNAL_REF
		return cancel;

	}
}