package com.fractalite.hermes.teldar.services;

import java.text.ParseException;

import javax.xml.datatype.DatatypeConfigurationException;

import org.apache.camel.Exchange;
import org.apache.camel.InvalidPayloadException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.fractalite.hermes.teldar.Marshaller.MarshallingJAXB;
import com.fractalite.hermes.teldar.cfg.TeldarRouteBuilder;
import com.gekko_holding.webservice.v2_4.CustomerIdentification;
import com.gekko_holding.webservice.v2_4.GetHotelDetails;
import com.gekko_holding.webservice.v2_4.HotelCode;
import com.gekko_holding.webservice.v2_4.HotelCodes;

public class GetHotelDetailsRequest extends TeldarServices {

	protected static Logger logger = LoggerFactory.getLogger(GetHotelDetailsRequest.class);

	@Override
	public void process(Exchange exchange)
			throws InvalidPayloadException, DatatypeConfigurationException, ParseException {

		logger.info("Invoking TELDAR GetHotelDetailsRequest Processor" +exchange.getIn().getBody());
		
		String hotelCode = exchange.getIn().getMandatoryBody(String.class);

		GetHotelDetails hoteldetailReq = getDetail(hotelCode);
		 logger.info("End TELDAR GetHotelDetailsRequest Processor......." +MarshallingJAXB.printXML(hoteldetailReq));
		exchange.getIn().setBody(hoteldetailReq, GetHotelDetails.class);
	}

	public GetHotelDetails getDetail(String code) throws ParseException, DatatypeConfigurationException {

		GetHotelDetails gethoteldetails = new GetHotelDetails();

		CustomerIdentification customeridentification = new CustomerIdentification();

		customeridentification.setClientId(TeldarRouteBuilder.clientId);
		customeridentification.setPassword(TeldarRouteBuilder.password);
		customeridentification.setCustomerKey(TeldarRouteBuilder.customerKey);
		
		gethoteldetails.setLanguage("EN");
		gethoteldetails.setIdentification(customeridentification);

		HotelCode hotelcode = new HotelCode();
		hotelcode.setCode(code);
		HotelCodes hotelsCode = new HotelCodes();
		hotelsCode.getHotelCode().add(hotelcode);
		gethoteldetails.setHotelCodes(hotelsCode);
		

		return gethoteldetails;

	}

}
