
package com.fractalite.hermes.teldar.services;

import java.text.ParseException;
import java.text.SimpleDateFormat;

import javax.xml.datatype.DatatypeConfigurationException;

import org.apache.camel.Exchange;
import org.apache.camel.InvalidPayloadException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import com.fractalite.hermes.teldar.Marshaller.MarshallingJAXB;
import com.fractalite.hermes.teldar.cfg.TeldarRouteBuilder;
import com.fractalite.models.commerce.QuoteTemplate;
import com.fractalite.models.travel.PaxType;
import com.fractalite.models.travel.Traveller;
import com.fractalite.models.travel.stay.HotelStay;
import com.fractalite.models.travel.stay.Occupancy2;
import com.fractalite.models.travel.stay.Room;
import com.gekko_holding.webservice.v2_4.AvailabilityCriteria;
import com.gekko_holding.webservice.v2_4.AvailabilityCriteria.RoomCriterias;
import com.gekko_holding.webservice.v2_4.Child;
import com.gekko_holding.webservice.v2_4.CustomerIdentification;
import com.gekko_holding.webservice.v2_4.DestinationCriteria;
import com.gekko_holding.webservice.v2_4.Facility;
import com.gekko_holding.webservice.v2_4.HotelAvailability;
import com.gekko_holding.webservice.v2_4.HotelCodeDestination;
import com.gekko_holding.webservice.v2_4.RoomPlan;
import com.gekko_holding.webservice.v2_4.RoomPlan.Children;


public class HotelQuotesRequest extends TeldarServices {

	protected static Logger logger = LoggerFactory.getLogger(HotelQuotesRequest.class);

	@Override
	public void process(Exchange exchange)
			throws InvalidPayloadException, ParseException, DatatypeConfigurationException {

	logger.trace("Invoking gooooo SearchHotelsPriceRequest Processor.......");
	QuoteTemplate q = exchange.getIn().getMandatoryBody(QuoteTemplate.class);
	HotelStay hotelstay = q.getTrip().getContent(HotelStay.class).get(0);
	exchange.setProperty("hermesquery", q);
	HotelAvailability teldarReq = getList(hotelstay);
	logger.info("End TELDAR QuoteRequest Processor......." + MarshallingJAXB.printXML(teldarReq));
	exchange.getIn().setBody(teldarReq, HotelAvailability.class);

}


public HotelAvailability getList(HotelStay hotelstay) throws ParseException, DatatypeConfigurationException
{
	HotelAvailability hotelavailability=new HotelAvailability();
	CustomerIdentification customeridentification=new CustomerIdentification();
	
	customeridentification.setClientId(TeldarRouteBuilder.clientId);
	customeridentification.setPassword(TeldarRouteBuilder.password);
	customeridentification.setCustomerKey(TeldarRouteBuilder.customerKey);
	 
	AvailabilityCriteria avaCriteria = new AvailabilityCriteria();
	SimpleDateFormat formatter = new SimpleDateFormat("yyyy-mm-dd");
	
	hotelavailability.setIdentification(customeridentification);
    
   DestinationCriteria destinationcriteria=new DestinationCriteria();
    
    HotelCodeDestination hotel = new HotelCodeDestination();
    hotel.setCode(hotelstay.getHotel().getCode());
   destinationcriteria.setHotel(hotel );
  
    avaCriteria.setDestinationCriteria(destinationcriteria);
    hotelavailability.setLanguage("EN");
    
    avaCriteria.setCheckIn(hotelstay.getCheckin().toString());
	avaCriteria.setCheckOut(hotelstay.getCheckout().toString());

	Facility facility=new Facility();
	facility.getCode();
	facility.getValue();
	
	
	RoomCriterias crit = new RoomCriterias();

	String roo = "";
	for (Room chambre : hotelstay.getRooms()) {

		Occupancy2 occupancy = new Occupancy2();
		RoomPlan roomoffers = new RoomPlan();
		
		int nbreOfAdult = 0;
		
		Children chlidren = new Children();
		for (Traveller traveller : chambre.getGuests()) {
			
			if (traveller.getClassification() == PaxType.ADULT)
				nbreOfAdult++;
			//else if (traveller.getClassification() == PaxType.CHILD) 
				else if (traveller.getClassification() == PaxType.INFANT) 
				{
				
					Child child=new Child();
					child.setAge(traveller.getAge());
					chlidren.getChild().add(child);
				}

			}
		occupancy.setAdults(nbreOfAdult);
		roomoffers.setRoomType(roo);
		roomoffers.setAdultsCount(nbreOfAdult);
	    roomoffers.setChildren(chlidren);	
		roomoffers.getRoomType();
		crit.getRoomPlan().add(roomoffers);

	}
	
	avaCriteria.setRoomCriterias(crit);

	hotelavailability.setAvailCriteria(avaCriteria);
	

	return hotelavailability;


	



}
}